// Create closure to keep namespace clean and hide implementation.
(function($) {
	$.fn.applyLocator = function(applyToClass) {
		var parent_obj = this;
		this.find('.nl_fourpp').keyup(function() {
			locator(parent_obj);
		});
	};
	 
	$.fn.locator = function(options) { 
        var instance = this;
        
        function getConfig(field) {
            if (typeof options === 'undefined' ||
            	typeof options[field] === 'undefined') {
                // Use default field class name
                return null;    
            } else {
                // Developer chose to specify form field manually.
                return options[field];    
            }
        } 
        instance.callback = getConfig('callback');
        locator(instance);
	};

	
	var pro6pp_cache = {};
	function pro6pp_cached_get(obj, url, callback) {
		if (pro6pp_cache.hasOwnProperty(url)) {
			callback(obj, pro6pp_cache[url]);
		} else {
			$.getJSON(url + "&callback=?", function(data) {
				pro6pp_cache[url] = data;
				callback(obj, data);
			});
		}
	}

    function pro6pp_post(obj, url, data, callback, callback_parameters) {
        $.ajax({url: url,
               type: 'post',
               data: data,
               crossDomain: true,
               success: function(json, textStatus, jqXHR) {
                   callback(obj, json, callback_parameters || []);
               }});
    }

	function locator(obj) {
		$(obj).find('.message').empty();
		var nl_fourpp = $(obj).find('.nl_fourpp').val();
		var target_nl_fourpps = $(obj).find('.target_nl_fourpps').val();
		// Trigger on '5408xb' and on '5408 xb'
		var nl_fourpp_regex = /[0-9]{4,4}\s?/;
		if (nl_fourpp_regex.test(nl_fourpp)) {
			var url = "http://api.pro6pp.nl/v1/locator";
			url = encodeURI(url);
//			pro6pp_cached_get(obj, url, fillin);
			// Use post to accomodate for big amount of target_nl_fourpps
            var data = {target_nl_fourpps: target_nl_fourpps,
                        auth_key: pro6pp_auth_key,
                        per_page: '3',
                        'nl_fourpp': nl_fourpp};
            pro6pp_post(obj, url, data, fillin);
		}
	}

	function fillin(obj, json) {
		var output = $(obj).find('.output').empty();

		if (json.status == 'ok') {
			if (typeof obj.callback !== 'undefined') { 
	            // When pressing tab, make a selection.
	        	obj.callback(json.results);
	        }
			$.each(json.results, function(i, result) {
				distance_km = Math.round(result.distance / 1000);
				output.append(
						"Winkel gevonden (" + result.nl_fourpp
								+ ") op een afstand van " + distance_km
								+ " km<br />").show();
			});	
		} else {
			var translated_message = json.error.message;
			if (json.error.message == 'nl_fourpp not found') {
				translated_message = 'Onbekende postcode';
			} else if (json.error.message == 'invalid target_nl_fourpps format') {
				translated_message = 'Ongeldig target_nl_fourpps formaat';
			}

			$(obj).find('.message').html(translated_message);
		}
	}
})(jQuery);
